Title
Array allocation overhead for non-allocating placement new
Status
cd5
Section
7.6.2.8 [expr.new]
Submitter
Paul Sanders

Created on 2018-07-16.00:00:00 last changed 4 months ago

Messages

Date: 2019-02-15.00:00:00

Proposed resolution (February, 2019):

  1. Change 7.6.2.8 [expr.new] paragraph 12 as follows:

  2. When a new-expression calls an allocation function and that allocation has not been extended, the new-expression passes the amount of space requested to the allocation function as the first argument of type std::size_t . That argument shall be no less than the size of the object being created; it may be greater than the size of the object being created only if the object is an array and the allocation function is not a non-allocating form (17.6.3.4 [new.delete.placement]). For arrays of...
  3. Change 7.6.2.8 [expr.new] paragraph 16 as follows:

  4. ...Here, each instance of x is a non-negative unspecified value representing array allocation overhead; the result of the new-expression will be offset by this amount from the value returned by operator new[]. This overhead may be applied in all array new-expressions, including those referencing a placement allocation function, but not when referencing the library function operator new[](std::size_t, void*) and other placement allocation functions. The amount of overhead may vary from one invocation of new to another. —end example]

(This resolution effectively resolves issue 476, which was closed for EWG input.)

Date: 2019-11-15.00:00:00

[Accepted as a DR at the November, 2019 meeting.]

According to 7.6.2.8 [expr.new] paragraph 12,

When a new-expression calls an allocation function and that allocation has not been extended, the new-expression passes the amount of space requested to the allocation function as the first argument of type std::size_t . That argument shall be no less than the size of the object being created; it may be greater than the size of the object being created only if the object is an array. For arrays of char, unsigned char, and std::byte, the difference between the result of the new-expression and the address returned by the allocation function shall be an integral multiple of the strictest fundamental alignment requirement (6.7.6 [basic.align]) of any object type whose size is no greater than the size of the array being created.

There is no exemption for the non-allocating (void*,size_t) placement-new allocation function, so programs must allow for the possibility that the provided buffer may need to be larger (by an indeterminate amount) than the size of an array placed into existing storage.

Should the non-allocating placement-new allocation function be exempt from the array allocation overhead? (This question was explicitly referred to CWG by the EWG chair.)

History
Date User Action Args
2020-12-15 00:00:00adminsetmessages: + msg6381
2018-07-16 00:00:00admincreate